


#include "stdafx.h"


#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <malloc.h>
#include <time.h>

#define _WIN32_WINNT 0x0400
#define _WIN32_DCOM


#include <windows.h>
#include "basetsd.h"



#include "Objbase.h"
//#include "Wbemidl.h"



#include <tchar.h>
#include <setupapi.h>
#include <winspool.h>
//#include <Wbemcli.h>

#include <comdef.h>

#include "oaidl.h"
#include "Ocidl.h" 

#include "Setupapi.h"



#include "SerialClass.h"



#define STEPPER_API




static HANDLE consoleh=NULL;


#define VSNPRINTF(a,b,c,d,e) ((((e)=_vsnprintf((a),(b),(c),(d)))<0)?((a)[(b)-1]=0,(e)):(e))

void xcprintf(char * format, ...)
{
 va_list   args;
 char      v[512];
 DWORD     numw;
// CONSOLE_SCREEN_BUFFER_INFO ConsoleScreenBufferInfo;


 if(consoleh==NULL && 0)
 {
  FreeConsole();
  AllocConsole(); 

  consoleh=GetStdHandle(STD_OUTPUT_HANDLE);

//  GetConsoleScreenBufferInfo(consoleh,&ConsoleScreenBufferInfo);
  
//  ConsoleScreenBufferInfo.dwSize.Y=256;

//  SetConsoleScreenBufferSize(consoleh,ConsoleScreenBufferInfo.dwSize);
 }


 va_start(args, format);
 numw=VSNPRINTF(v,(sizeof(v)-2)/sizeof(TCHAR),format,args,numw);
 strcat(v,"\r\n");
// WriteConsole(consoleh,v,strlen(v),&numw,NULL);

printf(v);

 va_end(args);
}



#ifdef _DEBUG


#define cprintf xcprintf

#else

extern int zcprintf(char * format, ...);


#define cprintf 1 || zcprintf

#endif


//----------------------------------------------------------------------------------------


#include "autohandle.h"
#include "autohmodule.h"
#include "autoheapalloc.h"


#define _countof(a) (sizeof(a)/sizeof(*(a)))


BOOL IsNumeric(char * pszString, BOOL bIgnoreColon)
{
  size_t nLen = strlen(pszString);
  if (nLen == 0)
    return FALSE;

  //What will be the return value from this function (assume the best)
  BOOL bNumeric = TRUE;

  for (size_t i=0; i<nLen && bNumeric; i++)
  {
    bNumeric = (isdigit(static_cast<int>(pszString[i])) != 0);
    if (bIgnoreColon && (pszString[i] == ':'))
      bNumeric = TRUE;
  }

  return bNumeric;
}


HMODULE LoadLibraryFromSystem32(LPCTSTR lpFileName)
{
  //Get the Windows System32 directory
  TCHAR szFullPath[_MAX_PATH];
  szFullPath[0] = _T('\0');
  if (GetSystemDirectory(szFullPath, _countof(szFullPath)) == 0)
    return NULL;

  //Setup the full path and delegate to LoadLibrary    
//  _tcscat_s(szFullPath, _countof(szFullPath), _T("\\"));
   strcat(szFullPath,_T("\\"));

//  _tcscat_s(szFullPath, _countof(szFullPath), lpFileName);
   strcat(szFullPath,lpFileName);

  return LoadLibrary(szFullPath);
}


typedef HKEY (__stdcall SETUPDIOPENDEVREGKEY)(HDEVINFO, PSP_DEVINFO_DATA, DWORD, DWORD, DWORD, REGSAM);
typedef BOOL (__stdcall SETUPDICLASSGUIDSFROMNAME)(LPCTSTR, LPGUID, DWORD, PDWORD);
typedef BOOL (__stdcall SETUPDIDESTROYDEVICEINFOLIST)(HDEVINFO);
typedef BOOL (__stdcall SETUPDIENUMDEVICEINFO)(HDEVINFO, DWORD, PSP_DEVINFO_DATA);
typedef HDEVINFO (__stdcall SETUPDIGETCLASSDEVS)(LPGUID, LPCTSTR, HWND, DWORD);
typedef BOOL (__stdcall SETUPDIGETDEVICEREGISTRYPROPERTY)(HDEVINFO, PSP_DEVINFO_DATA, DWORD, PDWORD, PBYTE, DWORD, PDWORD);



BOOL RegQueryValueString(HKEY kKey, LPCTSTR lpValueName, LPTSTR& pszValue)
{
  //Initialize the output parameter
  pszValue = NULL;

  //First query for the size of the registry value 
  DWORD dwType = 0;
  DWORD dwDataSize = 0;
  LONG nError = RegQueryValueEx(kKey, lpValueName, NULL, &dwType, NULL, &dwDataSize);
  if (nError != ERROR_SUCCESS)
  {
    SetLastError(nError);
    return FALSE;
  }

  //Ensure the value is a string
  if (dwType != REG_SZ)
  {
    SetLastError(ERROR_INVALID_DATA);
    return FALSE;
  }

  //Allocate enough bytes for the return value
  DWORD dwAllocatedSize = dwDataSize + sizeof(TCHAR); //+sizeof(TCHAR) is to allow us to NULL terminate the data if it is not null terminated in the registry
  pszValue = reinterpret_cast<LPTSTR>(LocalAlloc(LMEM_FIXED, dwAllocatedSize)); 
  if (pszValue == NULL)
    return FALSE;

  //Recall RegQueryValueEx to return the data
  pszValue[0] = _T('\0');
  DWORD dwReturnedSize = dwAllocatedSize;
  nError = RegQueryValueEx(kKey, lpValueName, NULL, &dwType, reinterpret_cast<LPBYTE>(pszValue), &dwReturnedSize);
  if (nError != ERROR_SUCCESS)
  {
    LocalFree(pszValue);
    pszValue = NULL;
    SetLastError(nError);
    return FALSE;
  }

  //Handle the case where the data just returned is the same size as the allocated size. This could occur where the data
  //has been updated in the registry with a non null terminator between the two calls to ReqQueryValueEx above. Rather than
  //return a potentially non-null terminated block of data, just fail the method call
  if (dwReturnedSize >= dwAllocatedSize)
  {
    SetLastError(ERROR_INVALID_DATA);
    return FALSE;
  }

  //NULL terminate the data if it was not returned NULL terminated because it is not stored null terminated in the registry
  if (pszValue[dwReturnedSize/sizeof(TCHAR) - 1] != _T('\0'))
    pszValue[dwReturnedSize/sizeof(TCHAR)] = _T('\0');

  return TRUE;
}



BOOL QueryRegistryPortName(HKEY hDeviceKey, int& nPort)
{
  //What will be the return value from the method (assume the worst)
  BOOL bAdded = FALSE;

  //Read in the name of the port
  LPTSTR pszPortName = NULL;
  if (RegQueryValueString(hDeviceKey, _T("PortName"), pszPortName))
  {
    //If it looks like "COMX" then
    //add it to the array which will be returned
    size_t nLen = _tcslen(pszPortName);
    if (nLen > 3)
    {
      if ((_tcsnicmp(pszPortName, _T("COM"), 3) == 0) && IsNumeric((pszPortName + 3), FALSE))
      {
        //Work out the port number
        nPort = _ttoi(pszPortName + 3);

        bAdded = TRUE;
      }
    }
    LocalFree(pszPortName);
  }

  return bAdded;
}



BOOL getcomport(int * pport)
{
  int nPort;
  *pport=-1;

  //Get the function pointers to "SetupDiGetClassDevs", "SetupDiGetClassDevs", "SetupDiEnumDeviceInfo", "SetupDiOpenDevRegKey" 
  //and "SetupDiDestroyDeviceInfoList" in setupapi.dll
  CAutoHModule setupAPI(LoadLibraryFromSystem32(_T("SETUPAPI.DLL")));
  if (setupAPI == NULL)
    return FALSE;

  SETUPDIOPENDEVREGKEY* lpfnSETUPDIOPENDEVREGKEY = reinterpret_cast<SETUPDIOPENDEVREGKEY*>(GetProcAddress(setupAPI, "SetupDiOpenDevRegKey"));
#if defined _UNICODE
  SETUPDICLASSGUIDSFROMNAME* lpfnSETUPDICLASSGUIDSFROMNAME = reinterpret_cast<SETUPDICLASSGUIDSFROMNAME*>(GetProcAddress(setupAPI, "SetupDiClassGuidsFromNameW"));
  SETUPDIGETCLASSDEVS* lpfnSETUPDIGETCLASSDEVS = reinterpret_cast<SETUPDIGETCLASSDEVS*>(GetProcAddress(setupAPI, "SetupDiGetClassDevsW"));
  SETUPDIGETDEVICEREGISTRYPROPERTY* lpfnSETUPDIGETDEVICEREGISTRYPROPERTY = reinterpret_cast<SETUPDIGETDEVICEREGISTRYPROPERTY*>(GetProcAddress(setupAPI, "SetupDiGetDeviceRegistryPropertyW"));
#else
  SETUPDICLASSGUIDSFROMNAME* lpfnSETUPDICLASSGUIDSFROMNAME = reinterpret_cast<SETUPDICLASSGUIDSFROMNAME*>(GetProcAddress(setupAPI, "SetupDiClassGuidsFromNameA"));
  SETUPDIGETCLASSDEVS* lpfnSETUPDIGETCLASSDEVS = reinterpret_cast<SETUPDIGETCLASSDEVS*>(GetProcAddress(setupAPI, "SetupDiGetClassDevsA"));
  SETUPDIGETDEVICEREGISTRYPROPERTY* lpfnSETUPDIGETDEVICEREGISTRYPROPERTY = reinterpret_cast<SETUPDIGETDEVICEREGISTRYPROPERTY*>(GetProcAddress(setupAPI, "SetupDiGetDeviceRegistryPropertyA"));
#endif
  SETUPDIDESTROYDEVICEINFOLIST* lpfnSETUPDIDESTROYDEVICEINFOLIST = reinterpret_cast<SETUPDIDESTROYDEVICEINFOLIST*>(GetProcAddress(setupAPI, "SetupDiDestroyDeviceInfoList"));
  SETUPDIENUMDEVICEINFO* lpfnSETUPDIENUMDEVICEINFO = reinterpret_cast<SETUPDIENUMDEVICEINFO*>(GetProcAddress(setupAPI, "SetupDiEnumDeviceInfo"));

  if ((lpfnSETUPDIOPENDEVREGKEY == NULL) || (lpfnSETUPDICLASSGUIDSFROMNAME == NULL) || (lpfnSETUPDIDESTROYDEVICEINFOLIST == NULL) ||
      (lpfnSETUPDIENUMDEVICEINFO == NULL) || (lpfnSETUPDIGETCLASSDEVS == NULL) || (lpfnSETUPDIGETDEVICEREGISTRYPROPERTY == NULL))
  {
    //Set the error to report
    setupAPI.m_dwError = ERROR_CALL_NOT_IMPLEMENTED;

    return FALSE;
  }
  
  //First need to convert the name "Ports" to a GUID using SetupDiClassGuidsFromName
  DWORD dwGuids = 0;
  lpfnSETUPDICLASSGUIDSFROMNAME(_T("Ports"), NULL, 0, &dwGuids);
  if (dwGuids == 0)
  {
    //Set the error to report
    setupAPI.m_dwError = GetLastError();

    return FALSE;
  }

  //Allocate the needed memory
  CAutoHeapAlloc guids;
  if (!guids.Allocate(dwGuids * sizeof(GUID)))
  {
    //Set the error to report
    setupAPI.m_dwError = ERROR_OUTOFMEMORY;

    return FALSE;
  }

  //Call the function again
  GUID* pGuids = static_cast<GUID*>(guids.m_pData);
  if (!lpfnSETUPDICLASSGUIDSFROMNAME(_T("Ports"), pGuids, dwGuids, &dwGuids))
  {
    //Set the error to report
    setupAPI.m_dwError = GetLastError();

    return FALSE;
  }

  //Now create a "device information set" which is required to enumerate all the ports
  HDEVINFO hDevInfoSet = lpfnSETUPDIGETCLASSDEVS(pGuids, NULL, NULL, DIGCF_PRESENT);
  if (hDevInfoSet == INVALID_HANDLE_VALUE)
  {
    //Set the error to report
    setupAPI.m_dwError = GetLastError();

    return FALSE;
  }

  //Finally do the enumeration
  BOOL bMoreItems = TRUE;
  int nIndex = 0;
  SP_DEVINFO_DATA devInfo;
  while (bMoreItems)
  {
    //Enumerate the current device
    devInfo.cbSize = sizeof(SP_DEVINFO_DATA);
    bMoreItems = lpfnSETUPDIENUMDEVICEINFO(hDevInfoSet, nIndex, &devInfo);
    if (bMoreItems)
    {
      //Did we find a serial port for this device
      BOOL bAdded = FALSE;

      //Get the registry key which stores the ports settings
      HKEY hDeviceKey = lpfnSETUPDIOPENDEVREGKEY(hDevInfoSet, &devInfo, DICS_FLAG_GLOBAL, 0, DIREG_DEV, KEY_QUERY_VALUE);
      if (hDeviceKey != INVALID_HANDLE_VALUE)
      {
        nPort = 0;
        if (QueryRegistryPortName(hDeviceKey, nPort))
        {
        #if defined CENUMERATESERIAL_USE_STL
//          ports.push_back(nPort);
        #else
//          ports.Add(nPort);
        #endif  
          bAdded = TRUE;
        }

        //Close the key now that we are finished with it
        RegCloseKey(hDeviceKey);
      }

      //If the port was a serial port, then also try to get its friendly name
      if (bAdded)
      {
        TCHAR szFriendlyName[1024];
        szFriendlyName[0] = _T('\0');
        DWORD dwSize = sizeof(szFriendlyName);
        DWORD dwType = 0;
        if (lpfnSETUPDIGETDEVICEREGISTRYPROPERTY(hDevInfoSet, &devInfo, SPDRP_DEVICEDESC, &dwType, reinterpret_cast<PBYTE>(szFriendlyName), dwSize, &dwSize) && (dwType == REG_SZ))
        {
        #if defined CENUMERATESERIAL_USE_STL
//          friendlyNames.push_back(szFriendlyName);
        #else
//          friendlyNames.Add(szFriendlyName);
        #endif  
         cprintf("name %s",szFriendlyName);
         if(strstr(szFriendlyName,"USB-SERIAL CH340"))
         {
          *pport=nPort;
         }
        }
        else
        {
        #if defined CENUMERATESERIAL_USE_STL
//          friendlyNames.push_back(_T(""));
        #else
//          friendlyNames.Add(_T(""));
        #endif  
        }
      }
    }

    ++nIndex;
  }

  //Free up the "device information set" now that we are finished with it
  lpfnSETUPDIDESTROYDEVICEINFOLIST(hDevInfoSet);

  //Return the success indicator
  return TRUE;
}




//-------------------------------------------------------------------------------------------




Serial* SP;


#define DEFDELAY (60*1000)

HANDLE ghSemaphore;

static int resetflag;


static char * readlnbase(int delay)
{
 static char buffer[1024];
 static char * p=buffer;
 static char * q=buffer;
 int           n;
 clock_t       timeout;
 

 timeout=delay+clock();

 while(1)
 {
  if(resetflag) return(NULL);

//  n=SP->ReadData(p,sizeof(buffer)-4-(p-buffer));
  n=SP->ReadData(p,1);

  if(n<=0)
  {
   if(clock()>timeout) return(NULL);
  }
  else
  {
//   cprintf("n chars %d",n);

   p+=n;
   *p=0;

//   cprintf("buffer %s",buffer);

   if((p-buffer+4)>=sizeof(buffer))
   {
    p=q=buffer;
    return(buffer);
   }

   while(q<p)
   {
    if(*q++<32)
    {
//     cprintf("read ln term %d",*(q-1));
     *(q-1)=0;
      p=q=buffer;
     if(*buffer) return(buffer);

    }
   }
  }
 }
}




static int seenmove;
static int moveposn;

static char * cachedcommand=NULL;
static char   cachebuffer[1024];



static char * readlnmiddle(int delay)
{
 char * p;
 int    posn;
 int    power;
 int    cn;


 p=readlnbase(delay);
 if(p)
 {
//  cprintf("rlm %s",p);
  if((cn=sscanf(p,"mv %d %d",&posn,&power))==2)
  {
   seenmove=1;
   moveposn=posn;
  }
  else
  {
   strcpy(cachebuffer,p);
   cachedcommand=cachebuffer;
  }
//  cprintf("cn %d seenmove %d",cn,seenmove);
 }

 return(p);
}




int TestMoveOver(int * posn,int delay)
{
 clock_t timeout=delay+clock();
 DWORD dwWaitResult;


// cprintf("tm in %d",seenmove);

 while(clock()<timeout)
 {
  if(seenmove) break;
  if(resetflag) break;

  dwWaitResult=WaitForSingleObject(ghSemaphore,0L);    
  if(dwWaitResult==WAIT_OBJECT_0)
  {
   if(!seenmove) readlnmiddle(delay);
   ReleaseSemaphore(ghSemaphore,1,NULL);
  }
  Sleep(100);
 }

// cprintf("tm ex %d",seenmove);

 if(resetflag) return(2);
 if(posn) *posn=moveposn;
 return(seenmove);
}







char * readln(int delay)
{
 char * p;
 clock_t timeout=delay+clock();
 DWORD dwWaitResult;


 while(clock()<timeout)
 {
  if(cachedcommand) break;
  if(resetflag) break;

  dwWaitResult=WaitForSingleObject(ghSemaphore,0L);    
  if(dwWaitResult==WAIT_OBJECT_0)
  {
   if(!cachedcommand) readlnmiddle(delay);
   ReleaseSemaphore(ghSemaphore,1,NULL);
  }
  Sleep(100);
 }

 if(resetflag) return(NULL);
 p=cachedcommand;
 cachedcommand=NULL;
 return(p); 
}




int writeserialport(int delay,char * format, ...)
{
 char v[1024];
 int  numw;
  va_list   args;
 DWORD dwWaitResult;

 if(resetflag) return(2);

 dwWaitResult=WaitForSingleObject(ghSemaphore,delay);    
 if(dwWaitResult==WAIT_OBJECT_0)
 {
  va_start(args, format);
  numw=VSNPRINTF(v,(sizeof(v)-2)/sizeof(TCHAR),format,args,numw);

  va_end(args);

  if(SP) SP->WriteData(v,strlen(v));

  ReleaseSemaphore(ghSemaphore,1,NULL);
 }

 return(0);
}




STEPPER_API int ResetArduino(unsigned int timeout)
{
 DWORD dwWaitResult;

 cprintf("doing reset");
 
 dwWaitResult=WaitForSingleObject(ghSemaphore,timeout);    
 if(dwWaitResult==WAIT_OBJECT_0)
 {
  if(SP) SP->Reset(timeout);
  ReleaseSemaphore(ghSemaphore,1,NULL);
 }

 return(0);
}



STEPPER_API int SetCancelState(int state)
{

 cprintf("set cancel flag %d",state);

 resetflag=state;

 return(0);
}





char * writeresponse(int delay,char * format, ...)
{
 char v[1024];
 int  numw;
 va_list   args;
 DWORD dwWaitResult;
 clock_t timeout=delay+clock();
 char * p=NULL;


 if(resetflag) return(NULL);

 dwWaitResult=WaitForSingleObject(ghSemaphore,delay);    
 if(dwWaitResult==WAIT_OBJECT_0)
 {
  va_start(args, format);
  numw=VSNPRINTF(v,(sizeof(v)-2)/sizeof(TCHAR),format,args,numw);

  va_end(args);

  if(SP)
  {
   SP->WriteData(v,strlen(v));

   while(clock()<timeout)
   {
    if(resetflag) break;
    if(cachedcommand) break;
    readlnmiddle(delay);
   }
   p=cachedcommand;
   cachedcommand=NULL;
  }
  ReleaseSemaphore(ghSemaphore,1,NULL);
 }

 return(p);
}



int dbprint(char * string)
{

 cprintf(string);
 return(0);
}



void stepperexit(void)
{

 
}



// from http://stackoverflow.com/questions/16898066/how-to-control-windows-services-using-windows-api-easily

void ShowLastError(char * what)
{
    LPVOID lpMsgBuf;

    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
        NULL,
        GetLastError(),
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
        (LPTSTR) &lpMsgBuf,
        0,
        NULL
    );

    // Display the string.
//    MessageBox(NULL, (char*)lpMsgBuf, what, MB_OK|MB_ICONINFORMATION);
	printf("%s:%s\r\n",(char*)lpMsgBuf, what);

    // Free the buffer.
    LocalFree(lpMsgBuf);
}



// from http://stackoverflow.com/questions/951016/how-to-set-dtr-rts-state-that-will-be-used-when-createfile-opens-com-port

int
EstablishDefaultDTR(char *comPortName, int dtr){
    char commandString[256];
    if ( !system(NULL) ){
        ShowLastError("system()");
        return(-1);
    }        
    sprintf( commandString, "MODE %s dtr=%s%", comPortName, dtr? "on":"off"  );
    return system( commandString );
}



#define MAX_SEM_COUNT 1


STEPPER_API int InitStp()
{
 int  port;
 char buffer[64];
 char buffer2[64];

 if(!getcomport(&port)) return(1);
 if(port<0) return(2);

 cprintf("Module start using port %d",port);


 
 sprintf(buffer2,"COM%d",port);

 if(port<10) sprintf(buffer,"COM%d",port);
 else        sprintf(buffer,"\\\\.\\COM%d",port);


 EstablishDefaultDTR(buffer2,0);

 SP = new Serial(buffer);    // adjust as needed

 if (SP->IsConnected()) cprintf("We're connected");
 else                   return(3);

 ghSemaphore = CreateSemaphore( 
        NULL,           // default security attributes
        MAX_SEM_COUNT,  // initial count
        MAX_SEM_COUNT,  // maximum count
        NULL);       

 if(ghSemaphore==NULL) cprintf("CreateSemaphore error: %d\n", GetLastError());


 return(0);
}





//-----------------------------------------------------------------------------------------



#define MAX_SENSORS 8

typedef struct bootblockstr
{
 time_t        basetime;
 unsigned long period; 
 int           recordsize;
 int           memorysize;
 int           nsensors;
 int           sensormodel[MAX_SENSORS];
 byte          sensorchannel[MAX_SENSORS]; 

 unsigned long lastgoodvalue;  

 int           vcc;
 time_t        now;
  
} bootblockstr;



 FILE         * spoolfp;

bootblockstr bootblock;
bootblockstr filebootblock;



void setup(void)
{
 bootblock.nsensors=4;
 bootblock.sensormodel[0]=0x1A2D;
 bootblock.sensormodel[1]=0xEA4C;
 bootblock.sensormodel[2]=0x1ABC;
 bootblock.sensormodel[3]=0xEA4C;
 bootblock.sensorchannel[0]=2;
 bootblock.sensorchannel[1]=4;
 bootblock.sensorchannel[2]=2;
 bootblock.sensorchannel[3]=1;
}



int sensorsread;
int temperatures[MAX_SENSORS];
int humidities[MAX_SENSORS];
int frequencies[MAX_SENSORS];
int vccs[MAX_SENSORS];



int atoix(char * string,int * len)
{
 char * p;
 int    val;
 int    c;


 p=string;
 val=0;

 while((c=tolower(*p++))!=0)
 {
  if(isdigit(c)) val=val*16+(c-'0');
  else
  if(c>='a' && c<='f') val=val*16+(c-'a'+10);
  else
  {
   p--;
   break;
  }
 }

 if(len) *len=p-string;

 return(val);
}


int ishex(char c)
{

 return(isdigit(c) || (tolower(c)>='a' && tolower(c)<='f'));
}


static int deresult;

int readvalue(char * p,int * val)
{
 char buffer[4];
 *val=255;
 if(!ishex(*p) || !ishex(*(p+1))) return(2);
 buffer[0]=*p;
 buffer[1]=*(p+1);
 buffer[2]=0;
 *val=atoix(buffer,NULL);
 if(*val!=0xDE) deresult=0;
 return(0);
}



void printsensorvalues(void)
{
 int i;
 
 for(i=0;i<bootblock.nsensors;i++)
 {
   printf("temp %d hum %d vcc %d freq %d\r\n",temperatures[i],humidities[i],vccs[i],frequencies[i]);
 }
}




int crackvalue(char * p)
{
 int i;
 int val;

 deresult=1;

 if(*p!='r' && *(p+1)!='v' && *(p+2)!=':') return(1);
 p+=3;

 
 for(i=0;i<bootblock.nsensors;i++)
 {

  if(bootblock.sensormodel[i]==0xEA4C)
  {
   if(readvalue(p,&val)) return(2);
   temperatures[i]=val*10; 
   p+=2;
  }
  else
  if(bootblock.sensormodel[i]==0x1A2D)
  {
   if(readvalue(p,&val)) return(2);
   temperatures[i]=val*10; 
   p+=2;
   if(readvalue(p,&val)) return(2);
   humidities[i]=val;
   p+=2;
  }
  else
  if(bootblock.sensormodel[i]==0x1ABC)
  {
   if(readvalue(p,&val)) return(2);
   temperatures[i]=val*10; 
   p+=2;
   if(readvalue(p,&val)) return(2);
   humidities[i]=val;
   p+=2;
   if(readvalue(p,&val)) return(2);
   vccs[i]=val;
   p+=2;
   if(readvalue(p,&val)) return(2);
   frequencies[i]=val*10;
   p+=2;
  }

 }

 return(0);
}





#define F_BASETIME 0x1
#define F_PERIOD 0x2
#define F_RECORDSIZE 0x4
#define F_MEMORYSIZE 0x8
#define F_LASTGOODVALUE 0x10
#define F_VCC 0x20
#define F_NOW 0x40

void getbootblock(void)
{
 int flags=0;
 char * p;

 writeserialport(DEFDELAY,"st\n");

 while(1)
 {
  p=readln(DEFDELAY);
  printf("%s\r\n",p);

      if(spoolfp) 
	  {
       fprintf(spoolfp,"get boot:%s\r\n",p);
       fflush(spoolfp);
	  }



  if(p)
  {
   if(sscanf(p,"basetime:%d",&bootblock.basetime)==1) flags|=F_BASETIME;
   if(sscanf(p,"period:%d",&bootblock.period)==1) flags|=F_PERIOD;
   if(sscanf(p,"recordsize:%d",&bootblock.recordsize)==1) flags|=F_RECORDSIZE;
   if(sscanf(p,"memorysize:%d",&bootblock.memorysize)==1) flags|=F_MEMORYSIZE;
   if(sscanf(p,"lastgoodvalue:%d",&bootblock.lastgoodvalue)==1) flags|=F_LASTGOODVALUE;
   if(sscanf(p,"vcc:%d",&bootblock.vcc)==1) flags|=F_VCC;
   if(sscanf(p,"now:%d",&bootblock.now)==1) flags|=F_NOW;

  }
  printf("flags %x\r\n",flags);
  if(flags==(F_BASETIME|F_PERIOD|F_RECORDSIZE|F_MEMORYSIZE|F_LASTGOODVALUE|F_VCC|F_NOW)) break;
 }


      if(spoolfp) 
	  {
       fprintf(spoolfp,"get boot flags %x\r\n",flags);
       fflush(spoolfp);
	  }


}


char * logfilename="logger.txt";
FILE * loggerfp;

#define BOOTBLOCKSPACE 512

void writelogfileblock(void)
{
 long here;
 int  n;
 char pad[32];
 int  i;

 fseek(loggerfp,0,SEEK_SET);

 fprintf(loggerfp,"basetime:%d\r\n",filebootblock.basetime);
 fprintf(loggerfp,"period:%d\r\n",filebootblock.period);
 fprintf(loggerfp,"recordsize:%d\r\n",filebootblock.recordsize);
 fprintf(loggerfp,"memorysize:%d\r\n",filebootblock.memorysize);
 fprintf(loggerfp,"lastgoodvalue:%d\r\n",filebootblock.lastgoodvalue);
 fprintf(loggerfp,"vcc:%d\r\n",filebootblock.vcc);
 fprintf(loggerfp,"now:%d\r\n",filebootblock.now);

 here=ftell(loggerfp);

 sprintf(pad,"                            \r\n");
 n=(BOOTBLOCKSPACE-here)/strlen(pad);
 for(i=0;i<n;i++) fprintf(loggerfp,pad);

 here=ftell(loggerfp);
 fprintf(loggerfp,pad+strlen(pad)-(BOOTBLOCKSPACE-here));

 fflush(loggerfp);
}


void getlogfile(void)
{
 int  flags=0;
 char string[256];
 char * p;


 loggerfp=fopen(logfilename,"r+");
 if(loggerfp)
 {
  while(1)
  {
   p=fgets(string,sizeof(string),loggerfp);
   printf("%s\r\n",string);
   if(p)
   {
    if(sscanf(p,"basetime:%d",&filebootblock.basetime)==1) flags|=F_BASETIME;
    if(sscanf(p,"period:%d",&filebootblock.period)==1) flags|=F_PERIOD;
    if(sscanf(p,"recordsize:%d",&filebootblock.recordsize)==1) flags|=F_RECORDSIZE;
    if(sscanf(p,"memorysize:%d",&filebootblock.memorysize)==1) flags|=F_MEMORYSIZE;
    if(sscanf(p,"lastgoodvalue:%d",&filebootblock.lastgoodvalue)==1) flags|=F_LASTGOODVALUE;
    if(sscanf(p,"vcc:%d",&filebootblock.vcc)==1) flags|=F_VCC;
    if(sscanf(p,"now:%d",&filebootblock.now)==1) flags|=F_NOW;

   }
   else
   {
    break;
   }
   printf("flags %x\r\n",flags);
   if(flags==(F_BASETIME|F_PERIOD|F_RECORDSIZE|F_MEMORYSIZE|F_LASTGOODVALUE|F_VCC|F_NOW)) break;
  }
 }
 else
 {
  printf("writing default log file\r\n");
  loggerfp=fopen(logfilename,"wb+");
  // set last good to oldest in memory
  filebootblock=bootblock;
  writelogfileblock();
  fflush(loggerfp);
 }
}


void logsensorvalues(unsigned int i)
{
 time_t t;
 struct tm * timeinfo;
 char buffer [80];
 int j;

 printf("log sensor values %d\r\n",i);

 t=bootblock.basetime+bootblock.period*i;
 timeinfo=gmtime(&t);
 strftime(buffer,sizeof(buffer),"%H:%M:%S %d/%m/%y",timeinfo);


 fprintf(loggerfp,"time:%d (%s) index:%d\r\n",t,buffer,i);

 if(deresult)
 {
  fprintf(loggerfp,"blanked result\r\n");
 }
 else
 {
  for(j=0;j<bootblock.nsensors;j++)
  {
   fprintf(loggerfp,"temp:%d humidity:%d vcc:%d frequency:%d\r\n",temperatures[j],humidities[j],vccs[j],frequencies[j]);
  }
 }
 fprintf(loggerfp,"\r\n");
}


char * spoolfilename="spool.txt";


int main(int argc, char* argv[])
{
 char         * p;
 unsigned int   i;
 unsigned int   oldest;
 unsigned int   wrap;
 int            error;


spoolfp=fopen(spoolfilename,"r+");

 cprintf("hello");
 printf("Hello World!\n");


      if(spoolfp) 
	  {
	   fseek(spoolfp,0,SEEK_END);
       fprintf(spoolfp,"\r\nstart up\r\n\r\n");
       fflush(spoolfp);
	  }


 setup();
 error=InitStp();
 if(error) 
 {
  printf("Error (%d) initialising serial device\r\n",error);
  exit(1);
 }


 getbootblock();
 getlogfile(); // comes after getbootblock

 wrap=bootblock.memorysize/bootblock.recordsize;
 if(bootblock.lastgoodvalue>(wrap-1)) oldest=bootblock.lastgoodvalue-(wrap-1);
 else                                 oldest=0;


 while(1)
 {
  i=filebootblock.lastgoodvalue;
  if(i<oldest) i=oldest;


  if(i!=bootblock.lastgoodvalue)
  {
   fseek(loggerfp,0,SEEK_END);
   while(i!=bootblock.lastgoodvalue)
   {
    writeserialport(DEFDELAY,"rv %d\n",i);
    while(1)
    {
     p=readln(DEFDELAY);

      if(spoolfp) 
	  {
       fprintf(spoolfp,"%s\r\n",p);
       fflush(spoolfp);
	  }


     if(p)
     {

      if(crackvalue(p)==0)
      {
       logsensorvalues(i);
       i++; 
	   break;
      } 
	 }
     else
     {
      break;
	 }
    }
   }

   filebootblock.lastgoodvalue=bootblock.lastgoodvalue;
   writelogfileblock();
   printf("write log file block\r\n");
  }

  p=readln(DEFDELAY);
  printf("%s\r\n",p);
  if(spoolfp) 
  {
   fprintf(spoolfp,"%s\r\n",p);
   fflush(spoolfp);
  }

  break;
 }

 return 0;
}

